/***************************************************************************
 *   Copyright (C) 2007  Antony Martin <martin.antony@yahoo.fr>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU General Public License           *
 *   as published by the Free Software Foundation; either version 2        *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

/* Cree le : 7 mars 2006
   derniere modification le 16/06/2007 */


#include <SCE/SCEMinimal.h>

/* CTypes.h est inclu dans Minimal.h */


size_t SCE_CSizeofType(SCEenum type)
{
    switch(type)
    {
        case SCE_DOUBLE:
            return (sizeof(GLdouble));
        
        case SCE_FLOAT:
            return (sizeof(GLfloat));
        
        case SCE_INT:
        case SCE_UNSIGNED_INT:
            return (sizeof(GLint));
        
        case SCE_SHORT:
        case SCE_UNSIGNED_SHORT:
            return (sizeof(GLshort));
        
        case SCE_BYTE:
        case SCE_UNSIGNED_BYTE:
            return (sizeof(GLbyte));
        
        #ifdef __SCE_DEBUG__
        default:
            Logger_Log(SCE_INVALID_ARG);
            Logger_LogMsg("unknown data type");
        #endif
    }
    
    return (0);
}


/* ajoute le 16/06/2007 */
int SCE_CGetInteger(SCEenum t)
{
    int v;
    glGetIntegerv(t, &v);
    return (v);
}

/* ajoute le 16/06/2007 */
float SCE_CGetFloat(SCEenum t)
{
    float v;
    glGetFloatv(t, &v);
    return (v);
}

/* ajoute le 16/06/2007 */
void SCE_CGetIntegerv(SCEenum t, int *v)
{
    glGetIntegerv(t, v);
}

/* ajoute le 16/06/2007 */
void SCE_CGetFloatv(SCEenum t, float *v)
{
    glGetFloatv(t, v);
}


#if 0
int SCE_CConvertType(SCEenum t_src, int s_src, void *src,
                     SCEenum t_dst, int s_dst, void *dst, SCEuint count)
{
    /* compteur */
    unsigned int i;
    
    /* pointeurs pour les conversions ... */
    /* pointeurs pour la source */
    GLubyte *ubyte_src = NULL;
    GLbyte *byte_src = NULL;
    GLushort *ushort_src = NULL;
    GLshort *short_src = NULL;
    GLuint *uint_src = NULL;
    GLint *int_src = NULL;
    GLfloat *float_src = NULL;
    GLdouble *double_src = NULL;
    /* pointeurs pour la destination */
    GLubyte *ubyte_dst = NULL;
    GLbyte *byte_dst = NULL;
    GLushort *ushort_dst = NULL;
    GLshort *short_dst = NULL;
    GLuint *uint_dst = NULL;
    GLint *int_dst = NULL;
    GLfloat *float_dst = NULL;
    GLdouble *double_dst = NULL;
    
    
    #define SCE_CONVERT_FOR(typeout, pout, pin)\
    case typeout:\
        pout = dst;\
        for(i=0; i<count; i++)\
        {\
            \
        }\
        pout = NULL;\
        break;
    
    #define SCE_SWITCH_FOR(typein, pin)\
    case typein:\
        pin = src;\
        switch(t_dst)\
        {\
            SCE_CONVERT_FOR(SCE_UNSIGNED_BYTE, ubyte_dst, pin)\
            SCE_CONVERT_FOR(SCE_BYTE, byte_dst, pin)\
            SCE_CONVERT_FOR(SCE_UNSIGNED_SHORT, ushort_dst, pin)\
            SCE_CONVERT_FOR(SCE_SHORT, short_dst, pin)\
            SCE_CONVERT_FOR(SCE_UNSIGNED_INT, uint_dst, pin)\
            SCE_CONVERT_FOR(SCE_INT, int_dst, pin)\
            SCE_CONVERT_FOR(SCE_FLOAT, float_dst, pin)\
            SCE_CONVERT_FOR(SCE_DOUBLE, double_dst, pin)\
        }\
        pin = NULL;\
        break;
    
    
    switch(t_src)
    {
        SCE_SWITCH_FOR(SCE_UNSIGNED_BYTE, ubyte_src)
        SCE_SWITCH_FOR(SCE_BYTE, byte_src)
        SCE_SWITCH_FOR(SCE_UNSIGNED_SHORT, ushort_src)
        SCE_SWITCH_FOR(SCE_SHORT, short_src)
        SCE_SWITCH_FOR(SCE_UNSIGNED_INT, uint_src)
        SCE_SWITCH_FOR(SCE_INT, int_src)
        SCE_SWITCH_FOR(SCE_FLOAT, float_src)
        SCE_SWITCH_FOR(SCE_DOUBLE, double_src)
    }
}
#endif
